(* Copyright (c) 2011. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets" by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook
*)
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, DB, DBClient, Grids, DBGrids, ExtCtrls, DBCtrls, Provider,
  DBTables;

type
  TForm1 = class(TForm)
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    PopupMenu1: TPopupMenu;
    Aboutthiscustomer1: TMenuItem;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    VisitwwwDephiDevelperDayscom1: TMenuItem;
    VisitwwwJensenDataSystemscom1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    Table1: TTable;
    DataSetProvider1: TDataSetProvider;
    Create1: TMenuItem;
    NewAggregateField1: TMenuItem;
    ClientDataSet1OrderNo: TFloatField;
    ClientDataSet1CustNo: TFloatField;
    ClientDataSet1SaleDate: TDateTimeField;
    ClientDataSet1ShipDate: TDateTimeField;
    ClientDataSet1EmpNo: TIntegerField;
    ClientDataSet1ShipToContact: TStringField;
    ClientDataSet1ShipToAddr1: TStringField;
    ClientDataSet1ShipToAddr2: TStringField;
    ClientDataSet1ShipToCity: TStringField;
    ClientDataSet1ShipToState: TStringField;
    ClientDataSet1ShipToZip: TStringField;
    ClientDataSet1ShipToCountry: TStringField;
    ClientDataSet1ShipToPhone: TStringField;
    ClientDataSet1ShipVIA: TStringField;
    ClientDataSet1PO: TStringField;
    ClientDataSet1Terms: TStringField;
    ClientDataSet1PaymentMethod: TStringField;
    ClientDataSet1ItemsTotal: TCurrencyField;
    ClientDataSet1TaxRate: TFloatField;
    ClientDataSet1Freight: TCurrencyField;
    ClientDataSet1AmountPaid: TCurrencyField;
    ClientDataSet1CustomerTotal: TAggregateField;
    procedure Aboutthiscustomer1Click(Sender: TObject);
    procedure ClientDataSet1CustomerTotalGetText(Sender: TField;
      var Text: String; DisplayText: Boolean);
    procedure About1Click(Sender: TObject);
    procedure VisitwwwDephiDevelperDayscom1Click(Sender: TObject);
    procedure VisitwwwJensenDataSystemscom1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ClientDataSet1CustNoGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure NewAggregateField1Click(Sender: TObject);
    procedure ClientDataSet1GetNumberSales(Sender: TField; var Text: String;
      DisplayText: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses ShellApi; //for ShellExecute

procedure TForm1.Aboutthiscustomer1Click(Sender: TObject);
begin
ShowMessage('The average sale to this customer is ' +
  Format('%.2m', [StrToFloat(ClientDataSet1.Aggregates[0].Value)]) +
  '. The first sale to this customer was on '+
  DateToStr(ClientDataSet1.Aggregates[1].Value));
end;

procedure TForm1.ClientDataSet1CustomerTotalGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  if gbLast in ClientDataSet1.GetGroupState(1) then
    Text := Format('%.2m',[StrToFloat(Sender.Value)])
  else
    Text := '';
end;

procedure TForm1.ClientDataSet1GetNumberSales(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  if gbLast in ClientDataSet1.GetGroupState(1) then
    Text := Sender.Value
  else
    Text := '';
end;


procedure TForm1.ClientDataSet1CustNoGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  if gbFirst in ClientDataSet1.GetGroupState(1) then
    Text := Sender.Value
  else
    Text := '';
end;

procedure TForm1.About1Click(Sender: TObject);
begin
ShowMessage('CDSAggs (c) 2002 Cary Jensen, Jensen Data Systems, Inc. '
  + #10#13 + ''
  + #10#13 + 'Demonstration of how to use aggregate fields, aggregates, and group state.'
  + #10#13 + 'This project is provided for demonstration purposes only.'
  + #10#13 + ''
  + #10#13 + 'Visit http://www.JensenDataSystems.com for information about training and consulting services.');
end;

procedure TForm1.VisitwwwDephiDevelperDayscom1Click(Sender: TObject);
begin
ShellExecute(Application.Handle, 'open',
 'http://www.DelphiDeveloperDays.com', nil, nil, SW_SHOW);
end;

procedure TForm1.VisitwwwJensenDataSystemscom1Click(Sender: TObject);
begin
ShellExecute(Application.Handle, 'open',
 'http://www.JensenDataSystems.com', nil, nil, SW_SHOW);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Self.Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
if FileExists('C:\Program Files\Common Files\Codegear Shared\Data\orders.cds') then
  ClientDataSet1.FileName := 'C:\Program Files\Common Files\Codegear Shared\Data\orders.cds'
else
if FileExists('C:\Program Files (x86)\Common Files\Codegear Shared\Data\orders.cds') then
  ClientDataSet1.FileName := 'C:\Program Files (x86)\Common Files\Codegear Shared\Data\orders.cds'
else
  ClientDataSet1.FileName := '';

end;

procedure TForm1.NewAggregateField1Click(Sender: TObject);
begin
  ClientDataSet1.DisableControls;
  ClientDataSet1.Close;
  try
    with TAggregateField.Create(Self) do
    begin
      FieldName := 'NumberOfSales';
      Expression := 'COUNT(OrderNo)';
      IndexName := 'CustIdx';
      GroupingLevel := 1;
      Active := True;
      Visible := True;
      Name := 'ClientDataSet1NumberOfSales';
      DataSet := ClientDataSet1;
    end;
    with DBGrid1.Columns.Add do
    begin
      FieldName := 'NumberOfSales';
      Title.Caption := 'Number of Sales';
      Index := 6;
     end;
    //Hook up the OnGetText event handler
    ClientDataSet1.FieldByName('NumberOfSales').OnGetText :=
      ClientDataSet1GetNumberSales;
    //Disable the menu to that creates the new AggregateField
    Create1.Enabled := False;
  finally
    //Enable controls and re-open the ClientDataSet
    ClientDataSet1.EnableControls;
    ClientDataSet1.Open;
  end;
end;

end.
