unit dynamicform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ExtCtrls, DBCtrls, Grids, DBGrids, DBClient, Provider, BDE, DBTables;

type
  TRuntimeForm = class(TForm)
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RuntimeForm: TRuntimeForm;

implementation

uses main;

{$R *.dfm}

procedure TRuntimeForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  //Enable the menu item used to create this form
    Form1.RuntimeConfiguration1.Enabled := True;
end;

procedure TRuntimeForm.FormCreate(Sender: TObject);
var
  CDS: TClientDataSet;
  DSP: TDataSetProvider;
  Table1: TTable;
begin
  //When configuring a ClientDataSet and
  //DataSetProvider using the ClientDataSet's
  //ProviderName, both must have the same owner,
  //and the DataSetProvider must have a name
  CDS := TClientDataSet.Create(Self);
  DSP := TDataSetProvider.Create(Self);
  Table1 := TTable.Create(Self);
  Table1.DatabaseName := 'DBDEMOS';
  Table1.TableName := 'CUSTOMER';
  DSP.Name := 'DSP1';
  CDS.ProviderName := DSP.Name;
  DSP.DataSet := Table1;
  CDS.Open;
  DataSource1.DataSet := CDS;
  //Disable the menu item used to create this form
  Form1.RuntimeConfiguration1.Enabled := False;
end;

end.
