(* Copyright (c) 2011. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets" by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook
*)
unit mainformu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXDataSnap, DBXCommon, SqlExpr, DB, DBClient, DSConnect, Grids,
  DBGrids, ExtCtrls, DBCtrls, Menus, StdCtrls, MConnect;

type
  TForm1 = class(TForm)
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    ClientDataSet1: TClientDataSet;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    ApplyUpdates1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TableNameComboBox: TComboBox;
    SQLMemo: TMemo;
    DCOMConnection1: TDCOMConnection;
    procedure Open1Click(Sender: TObject);
    procedure ApplyUpdates1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ApplyUpdates1Click(Sender: TObject);
begin
  ClientDataSet1.ApplyUpdates(0);
  ApplyUpdates1.Enabled := False;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  ApplyUpdates1.Enabled := ClientDataSet1.ChangeCount > 0;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  ClientDataSet1.Active := False;
  if DCOMConnection1.Connected then
    DCOMConnection1.Close;
  Close;
end;

procedure TForm1.Open1Click(Sender: TObject);
var
  SQLStmt: String;
begin
  if not ClientDataSet1.Active then
  begin
    if TableNameComboBox.ItemIndex = 0 then
      if SQLMemo.Lines.Text = '' then
        raise Exception.Create('Please supply a SQL statement')
      else
        SQLStmt := SQLMemo.Lines.Text
    else
      SQLStmt := 'SELECT * FROM ' +
        TableNameComboBox.Text;
    //Good to go
    ClientDataSet1.CommandText := SQLStmt;
    ClientDataSet1.Active := True;
    Open1.Caption := 'Close';
    ShowMessage(IntToStr(ClientDataSet1.RecordCount) +
      ' records were found for query ' + SQLStmt);
  end
  else
  begin
    ClientDataSet1.Active := False;
    DCOMConnection1.Close;
    Open1.Caption := 'Open';
    ApplyUpdates1.Enabled := False;
  end;
end;

end.
