(* Copyright (c) 2011. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets" by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook
*)
unit rdatamodu;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, ComServ, ComObj, VCLCom, DataBkr,
  DBClient, COMDataSnapOwnerDataServer_TLB, StdVcl, variants, DB, DBTables,
  Provider, mainformu;

type
  TDSComServerOwnerData = class(TRemoteDataModule, IDSComServerOwnerData)
    DataSetProvider1: TDataSetProvider;
    Query1: TQuery;
    procedure DataSetProvider1AfterGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
    procedure DataSetProvider1BeforeGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
  private
    { Private declarations }
  protected
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TDSComServerOwnerData.DataSetProvider1AfterGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
begin
  OwnerData := not Query1.CanModify;
end;

procedure TDSComServerOwnerData.DataSetProvider1BeforeGetRecords(
  Sender: TObject; var OwnerData: OleVariant);
var
  ms: TMemoryStream;
  TheFile: OleVariant;
  TheFilePointer: Pointer;
  TheFileName: String;
begin
  if not VarIsEmpty(OwnerData) then
  begin
    TheFileName := VarToStr(OwnerData[0]);
    TheFile := OwnerData[1];
    ms := TMemoryStream.Create;
    try
      TheFilePointer := VarArrayLock(TheFile);
      try
        ms.Write(TheFilePointer ^, VarArrayHighBound(TheFile, 1));
      finally
        VarArrayUnlock(TheFile);
      end;
      ms.Position := 0;
      ms.SaveToFile('c:\temp\text.txt');
      Form1.Caption := TheFileName;
    finally
      ms.Free;
    end;
  end;
end;

class procedure TDSComServerOwnerData.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

initialization
  TComponentFactory.Create(ComServer, TDSComServerOwnerData,
    Class_DSComServerOwnerData, ciMultiInstance, tmApartment);
end.
