(* Copyright (c) 2011. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets" by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook
*)
unit mainformu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBCtrls, Grids, DBGrids, DB, DBClient, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    Button2: TButton;
    DataSource1: TDataSource;
    ClientDataSet1: TClientDataSet;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if ClientDataSet1.Active then
    ClientDataSet1.Close;
  (**)
  with  ClientDataSet1.FieldDefs do
  begin
    Clear;
    with AddFieldDef do
    begin
      Name := 'ID';
      DataType := ftInteger;
    end; //with AddFieldDef do
    with AddFieldDef do
    begin
      Name := 'First Name';
      DataType := ftString;
      Size := 20;
    end; //with AddFieldDef do
    with AddFieldDef do
    begin
      Name := 'Last Name';
      DataType := ftString;
      Size := 25;
    end; //with AddFieldDef do
    with AddFieldDef do
    begin
      Name := 'Date of Birth';
      DataType := ftDate;
    end; //with AddFieldDef do
    with AddFieldDef do
    begin
      Name := 'Active';
      DataType := ftBoolean;
    end; //with AddFieldDef do
  end;
  ClientDataSet1.CreateDataSet;
   (**)
  (*
   //Add version
    with ClientDataSet1.FieldDefs do
    begin
      Clear;
      Add('ID',ftInteger, 0, True);
      Add('First Name',ftString, 20);
      Add('Last Name',ftString, 25);
      Add('Date of Birth',ftDate);
      Add('Active',ftBoolean);
    end; //with ClientDataSet1.FieldDefs
    ClientDataSet1.CreateDataSet;
   (**)
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  i: Integer;
begin
  if ClientDataSet1.Active then
    ClientDataset1.Close;
  for i := ClientDataSet1.Fields.Count - 1 downto 0 do
    ClientDataSet1.Fields[i].Free;

  with TIntegerField.Create(Self) do
  begin
    Name := 'ClientDataSet1ID';
    FieldKind := fkData;
    FieldName := 'ID';
    DataSet := ClientDataSet1;
  end; //ID
  with TStringField.Create(Self) do
  begin
    Name := 'ClientDataSet1FirstName';
    FieldKind := fkData;
    FieldName := 'First Name';
    Size := 20;
    DataSet := ClientDataSet1;
  end; //First Name
  with TStringField.Create(Self) do
  begin
    Name := 'ClientDataSet1LastName';
    FieldKind := fkData;
    FieldName := 'Last Name';
    Size := 25;
    DataSet := ClientDataSet1;
  end; //Last Name
  with TDateField.Create(Self) do
  begin
    Name := 'ClientDataSet1DateOfBirth';
    FieldKind := fkData;
    FieldName := 'Date of Birth';
    DataSet := ClientDataSet1;
  end; //Date of Birth
  with TBooleanField.Create(Self) do
  begin
    Name := 'ClientDataSet1Active';
    FieldKind := fkData;
    FieldName := 'Active';
    DataSet := ClientDataSet1;
  end; //Active Name
  ClientDataSet1.CreateDataSet;

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ClientDataSet1.EmptyDataSet;
  ClientDataSet1.Close;
  ClientDataSet1.FieldDefs.Clear;
  ClientDataSet1.Fields.Clear;
end;

end.
