(* Copyright (c) 2011. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets" by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook
*)
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls, DB, DBClient, Grids, DBGrids, DBCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    DataFileEdit: TEdit;
    Button1: TButton;
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    VisitwwwDephiDevelperDayscom1: TMenuItem;
    VisitwwwJensenDataSystemscom1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    File1: TMenuItem;
    CreateorLoad1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    ClientDataSet1: TClientDataSet;
    OpenDialog1: TOpenDialog;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Close1: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure VisitwwwDephiDevelperDayscom1Click(Sender: TObject);
    procedure VisitwwwJensenDataSystemscom1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure CreateorLoad1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ClientDataSet1AfterOpen(DataSet: TDataSet);
    procedure ClientDataSet1AfterClose(DataSet: TDataSet);
    procedure Close1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses ShellApi;

procedure TForm1.About1Click(Sender: TObject);
begin
ShowMessage('FieldDefs (c) 2002 Cary Jensen, Jensen Data Systems, Inc. '
  + #10#13 + ''
  + #10#13 + 'Demonstration of how to create a ClientDataSet''s structure using FieldDefs.'
  + #10#13 + 'This project is provided for demonstration purposes only.'
  + #10#13 + ''
  + #10#13 + 'Visit http://www.JensenDataSystems.com for information about training and consulting services.');

end;

procedure TForm1.VisitwwwDephiDevelperDayscom1Click(Sender: TObject);
begin
ShellExecute(Application.Handle, 'open',
 'http://www.DelphiDeveloperDays.com', nil, nil, SW_SHOW);
end;

procedure TForm1.VisitwwwJensenDataSystemscom1Click(Sender: TObject);
begin
ShellExecute(Application.Handle, 'open',
 'http://www.JensenDataSystems.com', nil, nil, SW_SHOW);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.CreateorLoad1Click(Sender: TObject);
begin
ClientDataSet1.FileName := DataFileEdit.Text;
if FileExists(ClientDataSet1.FileName) then
  ClientDataSet1.Open
else
  //AddFieldDef version
  begin
    with ClientDataSet1.FieldDefs do
    begin
      Clear;
      with AddFieldDef do
      begin
        Name := 'ID';
        DataType := ftInteger;
      end; //with AddFieldDef do
      with AddFieldDef do
      begin
        Name := 'First Name';
        DataType := ftString;
        Size := 20;
      end; //with AddFieldDef do
      with AddFieldDef do
      begin
        Name := 'Last Name';
        DataType := ftString;
        Size := 25;
      end; //with AddFieldDef do
      with AddFieldDef do
      begin
        Name := 'Date of Birth';
        DataType := ftDate;
      end; //with AddFieldDef do
      with AddFieldDef do
      begin
        Name := 'Active';
        DataType := ftBoolean;
      end; //with AddFieldDef do
    end; //with ClientDataSet1.FieldDefs
    ClientDataSet1.CreateDataSet;
  end; //else
  (**)
  (*
   //Add version
    begin
    with ClientDataSet1.FieldDefs do
    begin
      Clear;
      Add('ID',ftInteger, 0, True);
      Add('First Name',ftString, 20);
      Add('Last Name',ftString, 25);
      Add('Date of Birth',ftDate);
      Add('Active',ftBoolean);
    end; //with ClientDataSet1.FieldDefs
    ClientDataSet1.CreateDataSet;
  end; //else

   (**)
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ClientDataSet1.ChangeCount > 0 then
    ClientDataSet1.SaveToFile();
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DataFileEdit.Text := ExtractFilePath(Application.ExeName) + 'mydata.xml';
  OpenDialog1.Filename := DataFileEdit.Text;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if OpenDialog1.Execute then
  DataFileEdit.Text := OpenDialog1.FileName;
end;

procedure TForm1.ClientDataSet1AfterOpen(DataSet: TDataSet);
begin
 Close1.Enabled := True;
end;

procedure TForm1.ClientDataSet1AfterClose(DataSet: TDataSet);
begin
Close1.Enabled := False;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
 ClientDataSet1.SaveToFile;
 ClientDataSet1.Close;
end;

end.
