(* Copyright (c) 2011. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets" by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook
*)
unit IPServerMethodsu;

interface

uses
  SysUtils, Classes, DSServer, Provider, DB, DBTables, Windows;

type
  TServerMethods1 = class(TDSServerModule)
    Query1: TQuery;
    DataSetProvider1: TDataSetProvider;
  private
    { Private declarations }
  public
    { Public declarations }
    function EchoString(Value: string): string;
    function ReverseString(Value: string): string;
    {$IFDEF DEBUG}
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    {$ENDIF}
  end;

implementation

{$R *.dfm}

uses StrUtils;

{$IFDEF DEBUG}
constructor TServerMethods1.Create(AOwner: TComponent);
begin
  inherited;
  outputdebugstring(PChar('Starting the server methods object'));
end;

destructor TServerMethods1.Destroy;
begin
  outputdebugstring(PChar('stopping the server methods object'));
  inherited;
end;
{$ENDIF}

function TServerMethods1.EchoString(Value: string): string;
begin
  Result := Value;
end;

function TServerMethods1.ReverseString(Value: string): string;
begin
  Result := StrUtils.ReverseString(Value);
end;

end.

