(* Copyright (c) 2011. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets" by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook
*)
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DBTables, Provider, DB, DBClient, ExtCtrls, Grids,
  DBGrids, DBCtrls, Menus;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Panel1: TPanel;
    DBNavigator2: TDBNavigator;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    ClientDataSet1: TClientDataSet;
    ClientDataSet2: TClientDataSet;
    Panel2: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    VisitwwwDephiDevelperDayscom1: TMenuItem;
    VisitwwwJensenDataSystemscom1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Panel3: TPanel;
    Splitter1: TSplitter;
    IncludeCurrentOrderCbx: TCheckBox;
    DataSetProvider1: TDataSetProvider;
    Table1: TTable;
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure FormCreate(Sender: TObject);
    procedure IncludeCurrentOrderCbxClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure VisitwwwDephiDevelperDayscom1Click(Sender: TObject);
    procedure VisitwwwJensenDataSystemscom1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses ShellApi;

var
  PartFld: TField;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
  PartFld := ClientDataSet1.FieldByName('PartNo');
  ClientDataSet2.SetRange([PartFld.AsString], [PartFld.AsString]);
  if not IncludeCurrentOrderCbx.Checked then
    ClientDataSet2.Filter := 'OrderNo <> ' +
      QuotedStr(ClientDataSet1.FieldByName('OrderNo').AsString)
  else
    ClientDataSet2.Filter := '';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ClientDataSet1.Open;
  //Assign the OnDataChange event handler after
  //opening the ClientDataSet
  DataSource1.OnDataChange := DataSource1DataChange;
  //Clone the detail cursor.
  ClientDataSet2.CloneCursor(ClientDataSet1, True);
  //Create and assign an index to the cloned cursor
  ClientDataSet2.AddIndex('PartIndex','PartNo',[]);
  ClientDataSet2.IndexName := 'PartIndex';
  ClientDataSet2.Filtered := True;
  //Invoke the OnDataChange event handler to
  //create the detail view
  DataSource1DataChange(Self, PartFld);
end;

procedure TForm1.IncludeCurrentOrderCbxClick(Sender: TObject);
begin
  DataSource1DataChange(Self, ClientDataSet1.Fields[0]);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Exit;
end;

procedure TForm1.VisitwwwDephiDevelperDayscom1Click(Sender: TObject);
begin
ShellExecute(Application.Handle, 'open',
 'http://www.DelphiDeveloperDays.com', nil, nil, SW_SHOW);
end;

procedure TForm1.VisitwwwJensenDataSystemscom1Click(Sender: TObject);
begin
 ShellExecute(Application.Handle, 'open',
 'http://www.JensenDataSystems.com', nil, nil, SW_SHOW);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
ShowMessage('MasterDetailClone (c) 2002 Cary Jensen, Jensen Data Systems, Inc. '
  + #10#13
  + #10#13 + 'Demonstration of how to use a cloned ClientDataSet'
  + #10#13 + 'cursor to create a master/detail view with a single table.'
  + #10#13
  + #10#13 + 'This project is provided for demonstration purposes only.'
  + #10#13
  + #10#13 + 'Visit http://www.JensenDataSystems.com for information about training and consulting services.');

end;

end.
