(* Copyright (c) 2011. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets" by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook
*)
unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, DB, Menus, DBCtrls, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    VisitwwwDephiDevelperDayscom1: TMenuItem;
    VisitwwwJensenDataSystemscom1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    alentList1: TMenuItem;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    Splitter1: TSplitter;
    GroupBox2: TGroupBox;
    Splitter2: TSplitter;
    GroupBox3: TGroupBox;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DataSource3: TDataSource;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DBGrid3: TDBGrid;
    Label1: TLabel;
    TitleSearchEdit: TEdit;
    GroupBox4: TGroupBox;
    DBMemo1: TDBMemo;
    Panel3: TPanel;
    AddTalentEdit: TEdit;
    AddTalentButton: TButton;
    Label2: TLabel;
    VideoCount: TDBText;
    DBNavigator2: TDBNavigator;
    DBNavigator3: TDBNavigator;
    procedure AboutClick(Sender: TObject);
    procedure VisitwwwDephiDevelperDayscom1Click(Sender: TObject);
    procedure VisitwwwJensenDataSystemscom1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure alentList1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AddTalentButtonClick(Sender: TObject);
    procedure AddTalentEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TitleSearchEditChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses datamod, ShellAPI, TalentListu, typInfo;

{$R *.dfm}

procedure TForm1.AboutClick(Sender: TObject);
begin
ShowMessage('VideoLibrary (c) 2002 Cary Jensen, Jensen Data Systems, Inc. '
  + #10#13 + ''
  + #10#13 + 'Demonstration of how to create ClientDataSet structures using TFields.'
  + #10#13 + 'Unlike FieldDefs, TFields permit you to create virtual fields (aggregate, '
  + #10#13 + 'calculated, and lookup), as well as nested dataset fielkds'
  + #10#13 + 'This project is provided for demonstration purposes only.'
  + #10#13 + ''
  + #10#13 + 'Visit http://www.JensenDataSystems.com for information about training and consulting services.');

end;

procedure TForm1.VisitwwwDephiDevelperDayscom1Click(Sender: TObject);
begin
ShellExecute(Application.Handle, 'open',
 'http://www.DelphiDeveloperDays.com', nil, nil, SW_SHOW);
end;

procedure TForm1.VisitwwwJensenDataSystemscom1Click(Sender: TObject);
begin
ShellExecute(Application.Handle, 'open',
 'http://www.JensenDataSystems.com', nil, nil, SW_SHOW);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Self.Close;
end;

procedure TForm1.alentList1Click(Sender: TObject);
begin
with TTalentList.Create(Self) do
  Show;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
with DBGrid1 do
begin
  Columns.Clear;
  with Columns.Add do
  begin
    FieldName := 'Title';
//    Size := 100;
  end; //Title
  with Columns.Add do
  begin
    FieldName := 'Format';
    PickList.Add('DVD');
    PickList.Add('VHS');
    PickList.Add('Video-CD');
    PickList.Add('Music DVD');
    PickList.Add('CD-ROM');
    PickList.Add('Beta');
    PickList.Add('Other');
//    Size := 16;
  end; //Format
  with Columns.Add do
  begin
    FieldName := 'Category';
    PickList.Add('Action');
    PickList.Add('Comedy');
    PickList.Add('Drama');
    PickList.Add('Horror');
    PickList.Add('Music');
    PickList.Add('Special Interest');
    PickList.Add('Other');
//    Size := 16;
  end; //Format
  with Columns.Add do
  begin
    FieldName := 'Duration';
  end; //Format
  with Columns.Add do
  begin
    FieldName := 'DistributedBy';
//    Size := 72;
  end; //Format
  DBMemo1.DataField := 'Description';
with DBGrid2 do
  begin
  Columns.Clear;
  with Columns.Add do
    FieldName := 'Name';
  end;
with DBGrid3 do
  begin
  Columns.Clear;
  with Columns.Add do
    begin
    FieldName := 'SpecialFeature';
    Title.Caption := 'Special Feature';
    Width := 200;
    end;
  with Columns.Add do
    FieldName := 'Description';
  end;
end;
VideoCount.DataField := 'TotalTitles';
end;

procedure TForm1.AddTalentButtonClick(Sender: TObject);
var
  v: Variant;
  s: String;
begin
if AddTalentEdit.Text = '' then
begin
  ShowMessage('Enter the name of the Talent and click Add Talent');
  Exit;
end;
v := DataModule2.TalentCDS.Lookup('Name',AddTalentEdit.Text,'ID');
if VarIsNull(v) then
  begin
    if MessageDlg(AddTalentEdit.Text + ' not in Talent List. Add it?',mtConfirmation, mbOKCancel, 0) = mrOK then
      begin
        DataModule2.TalentCDS.Insert;
        DataModule2.TalentCDS.FieldByName('Name').AsString := AddTalentEdit.Text;
        DataModule2.TalentCDS.Post;
        s := DataModule2.TalentCDS.FieldByName('ID').AsString;
      end
    else
      Exit;
  end
  else
    s := v;
DataModule2.TalentByVideosCDS.Insert;
DataModule2.TalentByVideosCDS.FieldByName('TalentID').AsString := s;
DataModule2.TalentByVideosCDS.Post;
AddTalentEdit.Text := '';
AddTalentEdit.SetFocus;
end;

procedure TForm1.AddTalentEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = 13 then
  AddTalentButton.SetFocus;
end;

procedure TForm1.TitleSearchEditChange(Sender: TObject);
begin
DataModule2.VideosCDS.FindNearest([TitleSearchEdit.Text]);
end;

end.
